#!/bin/bash -e

docker pull docker.io/ceph/daemon:latest-octopus

#start client
cd client
HOSTNAME="$HOSTNAME" docker-compose up -d
cd -


# allow empty match on * to prevent manual check if role_dir and osd_dir exists
shopt -s nullglob

#bring up mon, mds, mgr
for role_dir in /ceph/m*; do
    role_name=$(basename "$role_dir")
    cd "$role_name"
    HOSTNAME="$HOSTNAME" docker-compose up -d
    cd -
done

#manually bring up osd
for osd_dir in /ceph/osd_*; do
    osd_name=$(basename "$osd_dir")
    osd_id=$(echo "$osd_name" | cut -d'_' -f2)
    
    #create temporary docker-compose.yml
    sed "s/%OSD_ID%/$osd_id/g" osd/docker-compose.yml > docker-compose.yml

    HOSTNAME="$HOSTNAME" docker-compose up -d

    #remove temporary docker-compose.yml
    rm docker-compose.yml
done